/* **********************************************************************
 * File  : buf.h                                                        *
 * Usage : Interface routines for dynamic buffer allocation.            *
 * By    : Sean Butler (Xin)                                            *
 *                                                                      *
 *                              For use with Finality, Version 1.0      *
 *                                      by Rasdan and Xin               *
 * Original CircleMUD code by Jeremy Elsen, John Hopkins University     *
 ********************************************************************** */

#define FALSE 0
#define TRUE (!FALSE)
#define ALLOC_SIZE 4096
#define NOT_ALLOCATED -1


/* SO that you can declare a buffer using BUF */
typedef long BUF;

/* create space fo a new buffer */
BUF newbuf(void);

/* Convert a buffer to a string */
char *buftos(BUF);

/* copy a string into a buffer */
BUF bufcpy(BUF, char *);

/* concatenate a string onto then end of a buffer */
BUF bufcat(BUF, char *);

/* print into a buffer using a format and variable number of args */
int bprintf(BUF, const char *, ...);

/* free a buffer, called before exiting function that calls newbuf() */
void bfree(BUF);

/* called at boot time to initialize the list of buffers. */
void initbufs(void);

